"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.argvMinimist = void 0;
const tslib_1 = require("tslib");
const argv_1 = require("./argv");
const errors_1 = require("./errors");
const plop_1 = require("./plop");
const launcher_1 = require("./plop/launcher");
const store_1 = require("./store");
const task_runtime_1 = require("./task-runtime");
const types_1 = require("./types");
tslib_1.__exportStar(require("./plop"), exports);
tslib_1.__exportStar(require("./types"), exports);
tslib_1.__exportStar(require("./utils"), exports);
tslib_1.__exportStar(require("./seeds"), exports);
tslib_1.__exportStar(require("./errors"), exports);
var argv_2 = require("./argv");
Object.defineProperty(exports, "argvMinimist", { enumerable: true, get: function () { return argv_2.argv; } });
process.on('uncaughtException', errors_1.errorHandler);
process.on('unhandledRejection', (error) => {
    throw error;
});
function run(config) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        try {
            const { binCmdKey, external } = config;
            store_1.configStore.setValue(store_1.configStore.keys.binCmdKey, binCmdKey);
            store_1.configStore.setValue(store_1.configStore.keys.external, external);
            if (argv_1.argv.help || argv_1.argv.h) {
                (0, plop_1.helpScreen)({
                    binCmdKey,
                });
                process.exit(0);
            }
            const [command = '', subcommand = ''] = argv_1.argv._.map((v) => `${v}`.toLowerCase());
            if (command === types_1.appCommand) {
                return (0, task_runtime_1.runTask)(subcommand, { binCmdKey });
            }
            const hasNotLoggedInBefore = !store_1.configStore.values.jfrog.username;
            (0, plop_1.initMessage)(external, hasNotLoggedInBefore);
            (0, launcher_1.launcher)();
            const exitCode = process.exitCode || 0;
            return exitCode;
        }
        catch (error) {
            (0, errors_1.errorHandler)(error);
        }
    });
}
exports.run = run;
