"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.storeSchema = void 0;
const tslib_1 = require("tslib");
const _2019_1 = tslib_1.__importDefault(require("ajv/dist/2019"));
const ajv = new _2019_1.default({
    strict: 'log',
});
const schema = {
    type: 'object',
    properties: {
        foo: {
            type: 'integer',
        },
        bar: {
            type: 'string',
            nullable: true,
        },
    },
    required: ['foo'],
    additionalProperties: false,
};
const validate = ajv.compile(schema);
const data = {
    foo: 1,
    bar: 'abc',
};
if (validate(data)) {
    console.log(data.foo);
}
else {
    console.log(validate.errors);
}
exports.storeSchema = {
    $schema: 'http://json-schema.org/schema#',
    $id: 'http://lcap.genesis.global/schemas/cli/store.json',
    title: 'A definition for cli config store',
    type: 'object',
    version: 1,
    required: ['version'],
    properties: {
        version: {
            title: 'The version of the schema the store maps to',
            type: 'number',
            enum: [1],
        },
    },
};
const validateStore = ajv.compile(exports.storeSchema);
const storeData = {
    version: 1,
};
if (validateStore(storeData)) {
    console.log(storeData.version);
}
else {
    console.log(validateStore.errors);
}
